-- na danou polohu zobrazi obrazek
local picture = {
  up= {
    name = {
      "/WIDGETS/SWImg2/img/0001.png",
      "/WIDGETS/SWImg2/img/0004.png",
      "/WIDGETS/SWImg2/img/0007.png",
      "/WIDGETS/SWImg2/img/0010.png",
      "/WIDGETS/SWImg2/img/0013.png",
      "/WIDGETS/SWImg2/img/0016.png",
      "/WIDGETS/SWImg2/img/0019.png",
      "/WIDGETS/SWImg2/img/0022.png",
      "/WIDGETS/SWImg2/img/0025.png",
      "/WIDGETS/SWImg2/img/0028.png",
      "/WIDGETS/SWImg2/img/0031.png",
      "/WIDGETS/SWImg2/img/0034.png",
      "/WIDGETS/SWImg2/img/0037.png",
      "/WIDGETS/SWImg2/img/0040.png",
      "/WIDGETS/SWImg2/img/0043.png",
      "/WIDGETS/SWImg2/img/0046.png",
      "/WIDGETS/SWImg2/img/0049.png",
      "/WIDGETS/SWImg2/img/0052.png",
      "/WIDGETS/SWImg2/img/0055.png",
      "/WIDGETS/SWImg2/img/0058.png",
  },
    len = 0,
    img = nil
  },
  mid= {
    name = {"/WIDGETS/SWImg2/img/0001.png"},
    len = 0,
    img = nil
  },
  down = {
    name = {"/WIDGETS/SWImg2/img/0001.png"},
    len = 0,
    img = nil
  },
  index = 1, -- pole zacinaji jednickou
  cnt = 0
}

local options = {
  {"Switch", SOURCE, 0},
  {"Top", VALUE, 0, 0, 100},
  {"Left", VALUE, 0, 0, 200},
  {"Delay", VALUE, 1, 0, 10 }
}

local function readAnim(imgs)
  local retval = {}
  local image = nil

  for i, v in pairs(imgs) do
    image = Bitmap.open(v)
    table.insert(retval, image)
  end

  return retval
end

local function tLength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

local function create(zone, options)
  local wgt = {zone = zone, options = options}

  picture.up.img = readAnim(picture.up.name)
  picture.up.len = tLength(picture.up.img)

  picture.mid.img = readAnim(picture.mid.name)
  picture.mid.len = tLength(picture.mid.img)

  picture.down.img = readAnim(picture.down.name)
  picture.down.len = tLength(picture.down.img)

  return wgt
end

local function update(wgt, options)
  if (wgt == nil) then
    return
  end
  wgt.options = options
end

local function background(wgt)
  return
end

------------------------------------------------------------

function refresh(wgt)
  if (wgt == nil) then
    return
  end

  if (wgt.options == nil) then
    return
  end

  if (wgt.options.Switch == nil) then
    return
  end

  local swPos = getValue(wgt.options.Switch)
  local i = wgt.options.Delay

  if (picture.cnt == 0) then
    picture.index = picture.index + 1
  end

  -- delay
  if picture.cnt > i then
    picture.cnt = 0
  else
    picture.cnt = picture.cnt + 1
  end


  local x = wgt.zone.x + wgt.options.Left
  local y = wgt.zone.y + wgt.options.Top

  local scale = 100
  if     wgt.zone.h > 165 then scale = 100
  elseif wgt.zone.h > 145 then scale = 100
  elseif wgt.zone.h >  65 then scale = 40
  elseif wgt.zone.h >  35 then scale = 25
  elseif wgt.zone.h >  28 then scale = 20
  end

  if (swPos > 10) then
    if (picture.index > picture.up.len) then picture.index = 1 end
    lcd.drawBitmap(picture.up.img[picture.index], x, y, scale)
  elseif (swPos < -10 ) then
    if (picture.index > picture.down.len) then picture.index = 1 end
    lcd.drawBitmap(picture.down.img[picture.index],x, y, scale)
  else
    if (picture.index > picture.mid.len) then picture.index = 1 end
    lcd.drawBitmap(picture.mid.img[picture.index], x, y, scale)
  end

  return
end

return {
  name = "SWImgAnim",
  options = options,
  create = create,
  update = update,
  background = background,
  refresh = refresh
}
